//
//  SharedData.h
//  HexFiend
//
//  Created by ridiculous_fish on Fri Jan 07 2005.
//  //  Copyright 2004-2006 ridiculous_fish. All rights reserved.
//

#import <Cocoa/Cocoa.h>

//an implementation of NSMutableData that tracks number of owners
//used for the fast path appending

@interface SharedData : NSMutableData {
    NSMutableData* myData;
    unsigned myUserCount;
}

+ withMutableData:(NSMutableData*)data;
- (void*)mutableBytes;
- (unsigned)length;
- (void)setLength:(unsigned)length;

- (void)incrementUser;
- (void)decrementUser;
- (unsigned)userCount;

@end
