//
//  PasteboardOwner.h
//  HexFiend
//
//  Created by ridiculous_fish on 8/25/05.
//  Copyright 2004-2006 ridiculous_fish. All rights reserved.
//

#import <Cocoa/Cocoa.h>

extern NSString * const PrivateByteArrayPasteboardType;

@class ByteArray;

@interface PasteboardOwner : NSObject {
	NSMutableDictionary* pasteboardPointersToByteArrays;
}

+ owner;

+ (NSData *)uuid;

//arr is not the internal structure, so we do not have to copy it
//when our data is requested as NSStringPboardType, type indicates what format we should give it
- (void)adoptByteArray:(ByteArray*)arr forPasteboard:(NSPasteboard*)board withStringType:(enum eDataStringType)type withBytesPerLine:(unsigned)bytesPerLine;

- (NSArray*)writablePasteboardTypes;

@end
